VERSION 5.00
Begin VB.Form frmTest 
   Caption         =   "  USB-Optp I/O 5+3"
   ClientHeight    =   1650
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4515
   LinkTopic       =   "Form1"
   ScaleHeight     =   1650
   ScaleWidth      =   4515
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame Frame4 
      Height          =   615
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   4275
      Begin VB.CommandButton cmdReadSerial 
         Caption         =   "Read"
         Height          =   375
         Left            =   2160
         TabIndex        =   13
         Top             =   180
         Width           =   855
      End
      Begin VB.TextBox txtSerNo 
         Height          =   315
         Left            =   120
         Locked          =   -1  'True
         TabIndex        =   12
         Top             =   180
         Width           =   1695
      End
      Begin VB.CommandButton cmdSerialConnect 
         Caption         =   "connect"
         Enabled         =   0   'False
         Height          =   375
         Left            =   3240
         TabIndex        =   11
         Top             =   180
         Width           =   915
      End
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test"
      Enabled         =   0   'False
      Height          =   435
      Left            =   1560
      Style           =   1  'Grafisch
      TabIndex        =   9
      Top             =   1020
      Width           =   675
   End
   Begin VB.Frame fraInputs 
      Caption         =   "inputs"
      Enabled         =   0   'False
      Height          =   615
      Left            =   2400
      TabIndex        =   4
      Top             =   900
      Width           =   1995
      Begin VB.CheckBox chkIn 
         BackColor       =   &H00FF0000&
         Enabled         =   0   'False
         Height          =   195
         Index           =   4
         Left            =   180
         Style           =   1  'Grafisch
         TabIndex        =   14
         Top             =   240
         Value           =   2  'Zwischenzustand
         Width           =   195
      End
      Begin VB.CheckBox chkIn 
         BackColor       =   &H00FF0000&
         Enabled         =   0   'False
         Height          =   195
         Index           =   3
         Left            =   540
         Style           =   1  'Grafisch
         TabIndex        =   8
         Top             =   240
         Width           =   195
      End
      Begin VB.CheckBox chkIn 
         BackColor       =   &H00FF0000&
         Enabled         =   0   'False
         Height          =   195
         Index           =   2
         Left            =   900
         Style           =   1  'Grafisch
         TabIndex        =   7
         Top             =   240
         Width           =   195
      End
      Begin VB.CheckBox chkIn 
         BackColor       =   &H00FF0000&
         Enabled         =   0   'False
         Height          =   195
         Index           =   1
         Left            =   1260
         Style           =   1  'Grafisch
         TabIndex        =   6
         Top             =   240
         Width           =   195
      End
      Begin VB.CheckBox chkIn 
         BackColor       =   &H00FF0000&
         Enabled         =   0   'False
         Height          =   195
         Index           =   0
         Left            =   1620
         Style           =   1  'Grafisch
         TabIndex        =   5
         Top             =   240
         Width           =   195
      End
   End
   Begin VB.Timer tmr 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   4080
      Top             =   660
   End
   Begin VB.Frame fraOutputs 
      Caption         =   "outputs"
      Enabled         =   0   'False
      Height          =   615
      Left            =   180
      TabIndex        =   0
      Top             =   900
      Width           =   1215
      Begin VB.CheckBox chkOut 
         Height          =   315
         Index           =   2
         Left            =   120
         TabIndex        =   3
         Top             =   180
         Width           =   315
      End
      Begin VB.CheckBox chkOut 
         Height          =   315
         Index           =   1
         Left            =   480
         TabIndex        =   2
         Top             =   180
         Width           =   315
      End
      Begin VB.CheckBox chkOut 
         Height          =   315
         Index           =   0
         Left            =   840
         TabIndex        =   1
         Top             =   180
         Width           =   315
      End
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function GetTickCount Lib "kernel32" () As Long

Private FTDI As clsUSB_SPS
Private mfAutoOutput As Boolean
Private miState As Integer

' Delayroutine fr Millisekunden (recht exakt)
Public Sub PauseMs(lDelay As Long)
  Dim lEnde As Long
  
  lEnde = GetTickCount + lDelay - 5
  Do
    DoEvents
  Loop Until GetTickCount > lEnde
End Sub

Private Sub chkOut_Click(Index As Integer)
   FTDI.BitOut(Index) = chkOut(Index).Value = 1
End Sub

Private Sub cmdReadSerial_Click()
  tmr.Enabled = False
  FTDI.Identify
  txtSerNo = FTDI.SerialNumber
  cmdTest.Enabled = False
  fraOutputs.Enabled = False
  fraInputs.Enabled = False
  cmdSerialConnect.Enabled = txtSerNo <> ""
End Sub

Private Sub cmdSerialConnect_Click()
  Dim i As Integer
  If txtSerNo <> "" Then
    If Not FTDI.Connect(txtSerNo) Then
      MsgBox "Fehler beim ffnen", vbCritical, "USB-Interface " & txtSerNo
      txtSerNo = ""
      Exit Sub
    Else
      cmdSerialConnect.Enabled = False
      cmdTest.Enabled = True
      fraOutputs.Enabled = True
      fraInputs.Enabled = True
    End If
  End If
  txtSerNo = FTDI.SerialNumber
  For i = 0 To 2
    FTDI.BitOut(i) = chkOut(i).Value = 1
  Next i
  tmr.Enabled = True
End Sub

Private Sub cmdTest_Click()
  mfAutoOutput = Not mfAutoOutput
End Sub

Private Sub Form_Load()
  Set FTDI = New clsUSB_SPS
End Sub

Private Sub tmr_Timer()
  Dim i As Integer
  
  For i = 0 To 4
    If FTDI.BitInput(i) Then
      chkIn(i).BackColor = vbButtonFace
    Else
      chkIn(i).BackColor = &HFF0000
    End If
  Next i
  For i = 0 To 2
    If FTDI.BitOut(i) Then
      chkOut(i).BackColor = &H180FF
    Else
      chkOut(i).BackColor = vbButtonFace
    End If
  Next i
  
  If mfAutoOutput Then
    Select Case miState
      Case 0
        FTDI.BitOut(0) = False
        FTDI.BitOut(1) = False
        FTDI.BitOut(2) = False
      Case 1
        FTDI.BitOut(0) = True
        FTDI.BitOut(1) = False
        FTDI.BitOut(2) = False
      Case 2
        FTDI.BitOut(0) = True
        FTDI.BitOut(1) = True
        FTDI.BitOut(2) = False
      Case 3
        FTDI.BitOut(0) = True
        FTDI.BitOut(1) = True
        FTDI.BitOut(2) = True
      Case 4
        FTDI.BitOut(0) = True
        FTDI.BitOut(1) = True
        FTDI.BitOut(2) = True
      Case 5
        FTDI.BitOut(0) = False
        FTDI.BitOut(1) = True
        FTDI.BitOut(2) = True
      Case 6
        FTDI.BitOut(0) = False
        FTDI.BitOut(1) = False
        FTDI.BitOut(2) = True
      Case 7
        FTDI.BitOut(0) = False
        FTDI.BitOut(1) = False
        FTDI.BitOut(2) = False
        miState = -1
    End Select
    miState = miState + 1
  End If
End Sub

Private Sub txtSerNo_Change()
  cmdSerialConnect.Enabled = txtSerNo.Text <> ""
End Sub
